__author__ = "Jonathan Heno"
__credits__ = ["Jonathan Heno"]
__version__ = "2.0.0"
__maintainer__ = "Jonathan Heno"
__email__ = ["jonathan.heno@alumni.univ-avignon.fr", "jheno84@gmail.com"]
__status__ = "dev"

import subprocess
import numpy
import argparse
import pathlib
import typing

import plt
import da

parser = argparse.ArgumentParser(
    prog="DQS benchmarker",
    description="Evaluates the DQS model on a probability scale by keeping track of the output files generated by the SSPSolv binary.",
)
parser.add_argument(
    "-c",
    "--cfg",
    type=pathlib.Path,
    required=True,
    help="Configuration file for the DQS.",
)
parser.add_argument(
    "-o", "--out_dir", type=pathlib.Path, required=True, help="Output directory."
)
parser.add_argument(
    "-g",
    "--granularity",
    type=int,
    required=True,
    help="Granularity to apply when splitting the probability space interval.",
    default=25,
)

ARGS = parser.parse_args()

EPSILON: numpy.float32 = 1.0e-5
UPDATE_COUNTER: numpy.uint = 50
PROBABILITIES = numpy.linspace(0.01, 1.0, ARGS.granularity, endpoint=True)
OUT_DIR = ARGS.out_dir
PLT_DIR = ARGS.out_dir / "plt"

for i, p in enumerate(PROBABILITIES):
    subprocess.call(
        f"cargo run --release -- -o {OUT_DIR}{' -c' if i == 0 else ''} -e {EPSILON} dqs -f {ARGS.cfg} -p {p:.3}".split(
            " "
        )
    )

    if i % UPDATE_COUNTER == 0 or i == len(PROBABILITIES) - 1:
        PLT_DIR.mkdir(exist_ok=True, parents=True)

        cfg, ds = da.load_data(OUT_DIR)
        ssp_stats: typing.Dict = {}

        if "ssp" in ds:
            plt.plot_ssp_dist(ds["ssp"], cfg, PLT_DIR)
        if "join_ssp" in ds:
            plt.plot_join_ssp(ds["join_ssp"], cfg, PLT_DIR)
        if "avg_nt" in ds:
            plt.plot_avg_nt(ds["avg_nt"], cfg, PLT_DIR)
